
{$G+}

Unit Graphics;

Interface
uses vars;
type VirtScrPtr=^FullScreenBtm;

var TheScreen,
    TheRealScreen:VirtScrPtr;
    OldExitProc:pointer;

Procedure SetCycle(Base:byte;Pal:PaletteType);
Function TopCap(What:byte):byte;   {maybe move this one??}
Procedure DisText(Wich:byte);
Procedure DulText(Wich:byte);
Procedure HiText(Wich:byte);
Procedure BrownPal;
Procedure BWPal;
Procedure HalfPal;
Procedure WaitScreen;
PROCEDURE GetRgbPalette(Color : BYTE; VAR Red, Green, Blue : BYTE);
Procedure ASetRGBPalette (Color,Red,Green,Blue: byte);
procedure putpixel(x,y:word;color:byte);
procedure SetVideoMode(mode:word);
procedure PushScreen;
procedure ClearScreen;
procedure AsmPush(Source,Dest:VirtScrPtr);
procedure AsmClear(Scr:VirtScrPtr);
Procedure FetchPal(var Pal:PaletteType);
Procedure PushFadeIn(Speed:Byte);
Procedure FadeIn(Speed:Byte;PAl:PaletteType);
Procedure FadeOut(Speed:Byte);
Procedure PushPalDeg(Deg:byte;Pal:palettetype);
Procedure Fadeto(Speed:Byte;PAl:PaletteType);
Procedure DownGamePal;


Implementation
{$F+}
procedure AsmPush(Source,Dest:VirtScrPtr);external;
procedure AsmClear(Scr:VirtScrPtr);external;{$L AsmStuff.Obj}
{$F-}
Procedure SetCycle(Base:byte;Pal:PaletteType);
 var
  c1:byte;
 begin
  For c1:=128 to 255 do
   asetrgbpalette(topcap(c1+base),Pal[c1].R,Pal[c1].G,Pal[c1].B);
 end;
Function TopCap(What:byte):byte;
 begin
  if what<128 then What:=What+128;
  TopCap:=What;
 end;
Procedure HiText(Wich:byte);
 begin
  AsetRgbPalette(Wich*3+10,63,55,33);
  AsetRgbPalette(Wich*3+11,50,45,25);
  AsetRgbPalette(Wich*3+12,41,36,21);{
  AsetRgbPalette(Wich*4+13,41,36,21); }
 end;
Procedure DisText(Wich:byte);
 begin
  AsetRgbPalette(Wich*3+10,12,11,10);
  AsetRgbPalette(Wich*3+11,9,8,7);
  AsetRgbPalette(Wich*3+12,6,5,4); {
  AsetRgbPalette(Wich*4+13,0,0,0);  }
 end;
Procedure DulText(Wich:byte);
 begin
  AsetRgbPalette(Wich*3+10,41,36,21);
  AsetRgbPalette(Wich*3+11,35,30,18);
  AsetRgbPalette(Wich*3+12,30,25,15);{
  AsetRgbPalette(Wich*4+13,20,17,10); }
 end;
Procedure DownGamePal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=64 to 128+63 do
   asetrgbpalette(c1,(Pal[c1].r*9) div 10,(Pal[c1].g*9) div 10,
   (Pal[c1].b*9) div 10);
 end;
Procedure HalfPal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=0 to 255 do
   asetrgbpalette(c1,Pal[c1].r div 2,Pal[c1].g div 2,Pal[c1].b div 2);
 end;

Procedure BWPal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=0 to 255 do
   begin
    Pal[c1].r:=(Pal[c1].r+Pal[c1].g+Pal[c1].b) div 3;
    Pal[c1].g:=Pal[c1].r;
    Pal[c1].b:=Pal[c1].g;
   end;
  For c1:=0 to 255 do
   asetrgbpalette(c1,Pal[c1].r,Pal[c1].g,Pal[c1].b);
 end;
Procedure BrownPal;
 var
  c1,c2:byte;
  pal:palettetype;
 begin
  FetchPal(Pal);
  For c1:=0 to 255 do
   begin
    Pal[c1].r:=(Pal[c1].r+Pal[c1].g+Pal[c1].b) div 3;
    Pal[c1].g:=Pal[c1].r;
    Pal[c1].b:=Pal[c1].g;
   end;
  For c1:=0 to 255 do
   asetrgbpalette(c1,Pal[c1].r,Pal[c1].g div 2,Pal[c1].b div 4);
 end;
Procedure PushPalDeg(Deg:byte;Pal:palettetype);
 var
  c1,c2:byte;
 begin
  For c1:=255 downto 0 do
    Asetrgbpalette(c1,Trunc(Pal[c1].R*deg/255),Trunc(Pal[c1].G*deg/255),
    Trunc(Pal[c1].B*deg/255));
 end;
Procedure FetchPal(var Pal:PaletteType);
 var
  c1:byte;
 begin
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
 end;

Procedure PushFadeIn(Speed:Byte);
 var
  c1,c2:byte;
  pal:PaletteType;
 begin
  if speed=0 then speed:=1;
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
  For c1:=0 to 255 do
   ASetRgbPalette(c1,0,0,0);
  PushScreen;
  For c2:=0 to Speed do
  begin
  For c1:=0 to 255 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
  end;
 end;
Procedure Fadeto(Speed:Byte;PAl:PaletteType);
 var
  c1,c2:byte;
  oldpal:PaletteType;
 begin
  fetchpal(oldpal);
  if speed=0 then speed:=1;
  For c2:=0 to Speed do
   begin
  For c1:=0 to 255 do
   AsetRgbPalette(c1,(OldPal[c1].R*(speed-c2)+Pal[c1].R*c2) div speed
   ,(OldPal[c1].g*(speed-c2)+Pal[c1].g*c2) div speed
   ,(OldPal[c1].b*(speed-c2)+Pal[c1].b*c2) div speed);
   waitscreen;
   end;
 end;
Procedure FadeIn(Speed:Byte;PAl:PaletteType);
 var
  c1,c2:byte;
 begin
  if speed=0 then speed:=1;
  For c2:=0 to Speed do
  begin
  For c1:=0 to 255 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
   end;
 end;
Procedure FadeOut(Speed:Byte);
 var
  c1,c2:byte;
  pal:PaletteType;
 begin
  if speed=0 then speed:=1;
  For c1:=0 to 255 do
   getRgbPalette(c1,Pal[c1].R,Pal[c1].G,Pal[c1].B);
  For c2:=Speed downto 0 do
  begin
  For c1:=0 to 255 do
   ASetRgbPalette(c1,Trunc(Pal[c1].R*c2/Speed),
   Trunc(Pal[c1].G*c2/Speed),Trunc(Pal[c1].B*c2/Speed));
   waitscreen;
   end;
 end;
PROCEDURE GetRgbPalette(Color : BYTE; VAR Red, Green, Blue : BYTE);
 Begin
  Port[$3C7]:=Color;
  Red:=Port[$3C9];
  Green:=Port[$3C9];
  Blue:=Port[$3C9];
 end;
     Procedure WaitScreen;
          Begin
               Repeat Until (Port[$3DA] and $08) <> 0;
               Repeat Until (Port[$3DA] and $08) = 0;
          end; {
Procedure WaitScreen;
 Begin
  while not ((Port[$3DA] and $08) = 0) do begin end;
  Repeat Until (Port[$3DA] and $08) <> 0;
 end;           }
Procedure ASetRGBPalette ( Color, Red, Green, Blue : Byte ); assembler;
asm
  mov dx,3c8h
  mov al, color
  out dx, al
  mov dx,3c9h
  mov al, red
  out dx,al
  mov al, green
  out dx,al
  mov al, blue
  out dx,al
End;             {
Procedure ASetRGBPalette (Color,Red,Green,Blue: byte);
 Begin
  Port[$3C8]:=Color;
  Port[$3C9]:=Red;
  Port[$3C9]:=Green;
  Port[$3C9]:=Blue;
 end;             }

procedure SetVideoMode(mode:word);assembler;
asm
   mov ax,mode
   xor ah,ah
   int 10h
end;

procedure PutPixel(x,y:word;color:byte);assembler;
asm
   push es
   mov ax,y
   mov bx,y
   shl ax,6
   shl bx,8
   add ax,bx
   add ax,x
   les di, TheScreen
   add di,ax
   mov al,color
   stosb
   pop es
end;

procedure PushScreen;
begin
   AsmPush(TheScreen,TheRealScreen);
end;

procedure ClearScreen;
begin
   AsmClear(TheScreen);
end;

procedure ExitProcedure;far;
begin
   ExitProc:=OldExitProc;
   dispose(TheScreen);
end;

begin
   new(TheScreen);
   ClearScreen;
   TheRealScreen:=ptr($A000,0000);
   OldExitProc:=ExitProc;
   ExitProc:=@ExitProcedure;
end.