unit cursor;

{
 Some cursor functions.

 Written by Scott Earnest (setech@ix.netcom.com) circa 1993.

 Brought up to date November 1995
}

interface

{$IFNDEF VER70}
const
  Seg0040 : word = $0040;
{$ENDIF}

procedure setcursorsize (ScanStart, ScanEnd : byte);
procedure getcursorsize (var ScanStart, ScanEnd : byte);
procedure hidecursor;
procedure showcursor;
function cursorhidden : boolean;

procedure StandardColCursor;
procedure StandardMonoCursor;
procedure PushCursor;
procedure PopCursor;

var
  StackCount : byte;

implementation

var
  StackBegin, StackEnd : array [1 .. 16] of byte;
  InitCount : byte;

procedure setcursorsize (ScanStart, ScanEnd : byte); assembler;

asm
  mov   ch,[ScanStart]
  mov   cl,[ScanEnd]
  mov   ah,01h
  int   10h
end;

procedure getcursorsize (var ScanStart, ScanEnd : byte);

begin
  ScanStart := mem[Seg0040:$0061];
  ScanEnd := mem [Seg0040:$0060];
end;

procedure HideCursor; assembler;

asm
  mov   es,[Seg0040]
  mov   di,0060h
  mov   cx,word ptr es:[di]
  mov   ax,0100h
  or    ch,20h
  int   10h
end;

procedure ShowCursor; assembler;

asm
  mov   es,[Seg0040]
  mov   di,0060h
  mov   cx,word ptr es:[di]
  mov   ax,0100h
  and   ch,0dfh
  int   10h
end;

function cursorhidden : boolean;

begin
  cursorhidden := (mem[Seg0040:$0061] and $20)=$20;
end;

procedure StandardColCursor;

begin
  setcursorsize ($06, $07);
end;

procedure StandardMonoCursor;

begin
  setcursorsize ($0b, $0c);
end;

procedure PushCursor;

begin
  if StackCount = 16 then exit;
  inc (StackCount);
  getcursorsize (StackBegin[StackCount], StackEnd[StackCount]);
end;

procedure PopCursor;

begin
  if StackCount = 0 then exit;
  setcursorsize (StackBegin[StackCount], StackEnd[StackCount]);
  dec (StackCount);
end;

begin
  StackCount := 0;    {Cursor size initial stack index = 0 (none stored)}
end.
