(**************************************************************************\
|                                                                          |
|  Scott Dudley    This unit handles a linked list. It can be reused in    |
|  CS 1053         any other program with minimal change of code, simply   |
|  11-23-94        write a new ConfType Unit. It is a Doubly Link List     |
|  Program 6       built with objects.                                     |
|  Link List                                                               |
|                                                                          |
\**************************************************************************)

Unit LnkLst;

Interface

Uses DatType;                       {Just change ConfType for use in }
 Type                                {another program}
   Point=^Cell;
   Cell=Object
     Info:Data;
     Next:Point;                     {A next AND previous pointer for easy}
     Previous:Point;                 {traversal}
    end;
   LinkList=Object                   {Note that its an OBJECT}
     Current:Point;
     Procedure Init;                 {Initilaize the list}
     Function  Empty:Boolean;        {Is the list empty?}
     Procedure Insert2left(Var Info:Data);{Insert a new node}
     Procedure Insert2right(Var Info:Data);{Insert a new node}
     Procedure Remove(var Info:Data);{Romove a node and pass on Data}
     Procedure Kill;                 {Remove a Node}
     Procedure MoveLeft;             {Move List.Current one node left}
     Procedure MoveRight;            {Move List.Current one node right}
     Procedure MoveFront;            {Move List.Current to the front}
     Procedure MoveEnd;              {Move List.Current to the end}
     Procedure CleanUp;              {Kill all Nodes in list}
    end;

Implementation

Procedure LinkList.Init;             {Initilaize the list}
 begin                               {Thats a tuff one eh?}
  Current:=Nil;
 end;

Function LinkList.Empty;             {Is the list empty?}
 begin                               {This ones pretty easy as well}
  Empty:=(Current=Nil);
 end;

Procedure LinkList.Insert2right;     {Insert a new node}
 var                                 {to the right of List.Current}
  Temp:Point;
 begin
  If LinkList.Empty then
   begin
    New(Temp);                       {Get a new node}
    Temp^.Info:=Info;                {Put the data in the node}
    Temp^.Next:=Nil;
    Temp^.Previous:=Nil;             {Change all the pointers}
    Current:=Temp                    {Set the current pointer to the new}
   end                               {node}
  else
   begin
    New(Temp);                       {Get a new node}
    Temp^.Info:=Info;                {Put the data in the node}
    Temp^.Next:=Current^.Next;
    Temp^.Previous:=Current;
    If Current^.Next<>Nil then Current^.Next^.Previous:=Temp;
    Current^.Next:=Temp;
    Current:=Temp;                   {Set the current pointer to the new}
   end;                              {node}
 end;
Procedure LinkList.Insert2left;      {Insert a new node}
 var                                 {to the left of List.Current}
  Temp:Point;
 begin
  If LinkList.Empty then
   begin
    New(Temp);                       {Get a new node}
    Temp^.Info:=Info;                {Put the data in the node}
    Temp^.Next:=Nil;
    Temp^.Previous:=Nil;             {Change all the pointers}
    Current:=Temp                    {Set the current pointer to the new}
   end                               {node}
  else
   begin

    New(Temp);                       {Get a new node}
    Temp^.Info:=Info;                {Put the data in the node}
    Temp^.Previous:=Current^.Previous;
    Temp^.Next:=Current;             {Change all the pointers}
    If Current^.Previous<>Nil then Current^.Previous^.Next:=Temp;
    Current^.Previous:=Temp;
    Current:=Temp;                   {Set the current pointer to the new}
   end;                              {node}
 end;

Procedure LinkList.Remove(var Info:Data);{Romove a node and pass on Data}
 var
  Temp:Point;
 begin
  If LinkList.Empty then
   begin
   end
  else
   begin
    Temp:=Current;                   {Set up the pointers}
    Info:=Temp^.Info;                {Pass on data}
    If Temp^.Next<>Nil then Temp^.Next^.Previous:=Temp^.Previous;
    If Temp^.Previous<>Nil then Temp^.Previous:=Temp^.Next;
    If Temp^.Previous=Nil then Current:=Temp^.Next
     else Current:=Temp^.Previous;
    Dispose(Temp);                   {Dispose of the cell}
   end;
 end;

Procedure LinkList.Kill;             {Remove a Node}
 var
  Temp:Point;
 begin
  If LinkList.Empty then
   begin
   end
  else
   begin
    Temp:=Current;                   {Set up the pointers}
    If Current^.Next<>Nil then Current^.Next^.Previous:=Current^.Previous;
    If Current^.Previous<>Nil then Current^.Previous^.Next:=Current^.Next;
    If Current^.Next=Nil then Current:=Current^.Previous
     else Current:=Current^.Next;
    If temp<>Nil then Dispose(Temp);      {Dispose of the cell}
   end;
 end;

Procedure LinkList.MoveLeft;         {Move List.Current one node left}
 begin                               {simple}
  If not LinkList.Empty then
  If Current<>Nil then
  If Current^.Previous<>Nil then
  Current:=Current^.Previous;
 end;

Procedure LinkList.MoveRight;        {Move List.Current one node right}
 Begin                               {simple}
  If not LinkList.Empty then
  If Current<>Nil then
  If Current^.Next<>Nil then
  Current:=Current^.Next;
 end;

Procedure LinkList.MoveFront;        {Move List.Current to the front}
 begin                               {Calls MoveLeft until it reaches the}
  If not LinkList.Empty then         {front of the list}
  While Current^.Previous<>Nil do
   LinkList.MoveLeft;
 end;

Procedure LinkList.MoveEnd;          {Move List.Current to the end}
 begin                               {Calls MoveRight util it reaches the}
  If not LinkList.Empty then         {end of the list}
  While Current^.Next<>Nil do
   LinkList.MoveRight;
 end;

Procedure LinkList.CleanUp;          {Kill all Nodes in list}
 var
  Temp:Point;
 begin
  While not LinkList.empty do        {Calls Kill until the list is empty}
   begin
    Write('.');
    LinkList.Kill;
   end;
 end;

End.

