program testmultkeys;

{
 Demonstration for MULTKEYS.PAS unit source.

 Written by Scott Earnest (setech@ix.netcom.com) -- if you use this source,
 please give credit where credit is due!

 What this demo does:  Displays all the different scancodes.  For each key
 pressed, the white "U" will change to a yellow-on-red "D".  To end the
 scancode demo, press [Alt] and [F10].  A second demo shows that the ISR
 is released.
}

uses
  multkeys, crt, cursor;


var
  PreviousKeyDown:byte;
  i : byte;


Function WhatKeyDown:byte;
 var
  c1,c2:byte;
 begin
  if not(GlobalKeyDown) then
   begin
    PreviousKeyDown:=128;
    WhatKeyDown:=128;
   end
  else
    BEGIN
     if not(KeyDown[PreviousKeyDown]) then
      begin
       PreviousKeyDown:=128;
       c2:=128;
       for c1:=0 to 127 do
        begin
          if keydown[c1] then
           begin
            PreviousKeyDown:=c1;
            c2:=c1;
           end;
        end;
      end else
      begin
       c2:=PreviousKeyDown;
       for c1:=0 to PreviousKeyDown-1 do
        begin
          if keydown[c1] then
          c2:=c1;
        end;
       for c1:=PreviousKeyDown+1 to 127 do
        begin
          if keydown[c1] then
          c2:=c1;
        end;
      WhatKeyDown:=c2;
     END;
    END;
 end;

procedure charstate (state : boolean);

var
  a : byte;

begin
  a := textattr;
  write (' ');
  case state of
    false : write ('U');
    true  : begin
              textattr := $4e;
              write ('D');
              textattr := a;
            end;
  end;
end;

procedure writehexbyte (b : byte);

const
  nib : array[0..15] of char = '0123456789abcdef';

begin
  write (' $',nib[b div 16],nib[b mod 16]);
end;

var
  l : byte;
  ch : char;

begin
  textattr := $0f;
  clrscr;
  gotoxy (1,25);
  write ('Multiple keypress demo, press [Alt] and [F10] to stop.');
  hidecursor;
  repeat
    gotoxy (1,1);
    for i := 0 to 127 do
      begin
        writehexbyte (i);
        charstate(keydown[i]);
        write ('':2);
      end;
    gotoxy (1,22);
    write ('GlobalKeyDown = ',GlobalKeyDown,' ');
    gotoxy (1,23);
    write ('WhatKeyDown = ',WhatKeyDown,' ');
  until keydown[key_F10] and keydown[key_Alt];
  gotoxy (1,25);
  clreol;
  showcursor;
end.
