{$G+}
Unit Graphics;

Interface

type VirtScrPtr=^VirtScr;
     VirtScr=array[0..64000] of byte;
     OneCharacter=array[0..7] of byte;
     CharacterSet=array[0..127] of OneCharacter;

var TheScreen,
    TheRealScreen:VirtScrPtr;
    OldExitProc:pointer;
    CurrentX,
    CurrentY:word;
    CharSet:CharacterSet ABSOLUTE $F000:$FA6E;


procedure line(x1,y1,x2,y2:word;color:byte);
Procedure ASetRGBPalette (Color,Red,Green,Blue: byte);
Procedure WaitScreen;
procedure writetext(s:string);
{procedure writelntext(s:string);}
procedure goto_xy(x,y:word);
function where_x:word;
function where_y:word;
procedure putpixel(x,y:word;color:byte);
procedure SetVideoMode(mode:word);
procedure PushScreen;
procedure ClearScreen;
procedure drawcircle(x,y,r:integer;color:byte);

Implementation

{$F+}
procedure AsmPush(Source,Dest:VirtScrPtr);external;
procedure AsmClear(Scr:VirtScrPtr);external;{$L AsmStuff.Obj}

procedure Line(x1,y1,x2,y2:word;color:byte);external;{$L line.obj}
{$F-}

procedure drawcircle(x,y,r:integer;color:byte);
var i,row,col,px,py:integer;
    sum:longint;
begin
     py:=r shl 1;
     px:=0;
     sum:=-py;
     while (px<=py) do
     begin
          if (px AND 1)=0 then
          begin
               col:=x+(px shr 1);
               row:=y+(py shr 1);
               putpixel(col,row,color);
               row:=y-(py shr 1);
               putpixel(col,row,color);
               col:=x-(px shr 1);
               putpixel(col,row,color);
               row:=y+(py shr 1);
               putpixel(col,row,color);
               col:=x+(py shr 1);
               row:=y+(px shr 1);
               putpixel(col,row,color);
               row:=y-(px shr 1);
               putpixel(col,row,color);
               col:=x-(py shr 1);
               putpixel(col,row,color);
               row:=y+(px shr 1);
               putpixel(col,row,color);
          end;
          sum:=sum+px+px+1;
          inc(px);
          if (sum>=0) then
          begin
               sum:=sum-py-py-1;
               dec(py);
          end;
     end;
end;
Procedure ASetRGBPalette (Color,Red,Green,Blue: byte);
 Begin
  Port[$3C8]:=Color;
  Port[$3C9]:=Red;
  Port[$3C9]:=Green;
  Port[$3C9]:=Blue;
 end;

Procedure WaitScreen;
 Begin
  while not ((Port[$3DA] and $08) = 0) do begin end;
  Repeat Until (Port[$3DA] and $08) <> 0;
 end;
procedure DrawCharacter(c:char);
var i,j:byte;
begin
   for i:=0 to 7 do
      for j:=0 to 7 do
         if (CharSet[ord(c)][i] AND ($80 SHR j)<>0) then
            PutPixel(CurrentX+j,CurrentY+i,5);
end;

procedure WriteText(s:string);
var i:byte;
begin
   for i:=1 to length(s) do
      begin
      DrawCharacter(s[i]);
      inc(CurrentX,8);
      end;
end;

procedure Goto_XY(x,y:word);
begin
   if (y>24) or (x>79) then exit;
   CurrentX:=x*8;
   CurrentY:=y*320*8;
end;

function Where_X:word;
begin
   Where_X:=CurrentX div 8;
end;

function Where_Y:word;
begin
   Where_Y:=CurrentY div (320*8);
end;

procedure SetVideoMode(mode:word);assembler;
asm
   mov ax,mode
   xor ah,ah
   int 10h
end;

procedure PutPixel(x,y:word;color:byte);assembler;
asm
   push es
   mov ax,y
   mov bx,y
   shl ax,6
   shl bx,8
   add ax,bx
   add ax,x
   les di, TheScreen
   add di,ax
   mov al,color
   stosb
   pop es
end;

procedure PushScreen;
begin
   AsmPush(TheScreen,TheRealScreen);
end;

procedure ClearScreen;
begin
   AsmClear(TheScreen);
end;

procedure ExitProcedure;far;
begin
   ExitProc:=OldExitProc;
   dispose(TheScreen);
end;

begin
   new(TheScreen);
   ClearScreen;
   TheRealScreen:=ptr($A000,0000);
   CurrentX:=0;
   CurrentY:=0;
   OldExitProc:=ExitProc;
   ExitProc:=@ExitProcedure;
end.