SCREEN_WIDTH    equ 320
SCREEN_SEGMENT  equ 0a000h
     .model TPascal
     .code

parms  struc
        dw ?                    ;bp
        dw ?                    ;cs <-v
        dw ?                    ;ip <-^
Color   db ?
        db ?
YEnd    dw ?
XEnd    dw ?
YStart  dw ?
XStart  dw ?
parms ends

AdjUp  equ -2
AdjDown equ -4
WholeStep equ -6
XAdvance equ -8
LOCAL_SIZE equ 8

public Line

Line proc far
   cld
   push bp
   mov bp,sp
   sub sp,LOCAL_SIZE             ;allocate local variable space
   push si di ds
   mov ax,[bp].YStart
   cmp ax,[bp].YEnd
   jle LineIsTopToBottom
   xchg [bp].YEnd,ax
   mov  [bp].YStart,ax
   mov bx,[bp].XStart
   xchg [bp].XEnd,bx
   mov [bp].XStart,bx
LineIsTopToBottom:
   mov dx,SCREEN_WIDTH
   mul dx                          ;use shifts??
   mov si,[bp].XStart
   mov di,si
   add di,ax

   mov cx,[bp].YEnd
   sub cx,[bp].YStart

   mov dx,[bp].XEnd
   sub dx,si
   jnz NotVerticalLine
   mov ax,SCREEN_SEGMENT
   mov ds,ax
   mov al,[bp].Color
VLoop:
   mov [di],al
   add di,SCREEN_WIDTH
   dec cx
   jns VLoop
   jmp done

;   align 2
IsHorizontalLine:
   mov ax,SCREEN_SEGMENT
   mov es,ax
   mov al,[bp].Color
   mov ah,al
   and bx,bx
   jns DirSet
   sub di,dx
DirSet:
   mov cx,dx
   inc cx
   shr cx,1
   rep stosw
   adc cx,cx
   rep stosb
   jmp Done

;   align 2
IsDiagonalLine:
   mov ax,SCREEN_SEGMENT
   mov ds,ax
   mov al,[bp].Color
   add bx,SCREEN_WIDTH
DLoop:
   mov [di],al
   add di,bx
   dec cx
   jns DLoop
   jmp Done

;   align 2
NotVerticalLine:
   mov bx,1
   jns LeftToRight
   neg bx
   neg dx
LeftToRight:
   and cx,cx
   jz IsHorizontalLine

   cmp cx,dx
   jz IsDiagonalLine

   cmp dx,cx
   jae XMajor
   jmp YMajor

;   align 2
XMajor:
   mov ax,SCREEN_SEGMENT
   mov es,ax
   and bx,bx
   jns DFSet
   std
DFSet:
   mov ax,dx
   sub dx,dx
   div cx
   mov bx,dx
   add bx,bx
   mov [bp].AdjUp,bx
   mov si,cx
   add si,si
   mov [bp].AdjDown,si
   sub dx,si
   mov si,cx
   mov cx,ax
   shr cx,1
   inc cx
   push cx

   add dx,si
   test al,1
   jnz XMajorAdjustDone
   dec cx
XMajorAdjustDone:
   mov [bp].WholeStep,ax
   mov al,[bp].Color
   rep stosb
   add di,SCREEN_WIDTH
   cmp si,1
   jna XMajorDrawLast
   dec dx
   shr si,1
   jnc XMajorFullRunsOddEntry
XMajorFullRunsLoop:
   mov cx,[bp].WholeStep
   add dx,bx
   jnc XMajorNoExtra
   inc cx
   sub dx,[bp].AdjDown
XMajorNoExtra:
   rep stosb
   add di,SCREEN_WIDTH
XMajorFullRunsOddEntry:
   mov cx,[bp].WholeStep
   add dx,bx
   jnc XMajorNoExtra2
   inc cx
   sub dx,[bp].AdjDown
XMajorNoExtra2:
   rep stosb
   add di,SCREEN_WIDTH
   dec si
   jnz XMajorFullRunsLoop
XMajorDrawLast:
   pop cx
   rep stosb
   cld
   jmp Done

;   align 2
YMajor:
   mov [bp].XAdvance,bx
   mov ax,SCREEN_SEGMENT
   mov ds,ax
   mov ax,cx
   mov cx,dx
   sub dx,dx
   div cx
   mov bx,dx
   add bx,bx
   mov [bp].AdjUp,bx
   mov si,cx
   add si,si
   mov [bp].AdjDown,si
   sub dx,si
   mov si,cx
   mov cx,ax
   shr cx,1
   inc cx
   push cx

   add dx,si
   test al,1
   jnz YMajorAdjustDone
   sub dx,si
   and bx,bx
   jnz YMajorAdjustDone
   dec cx
YMajorAdjustDone:
   mov [bp].WholeStep,ax
   mov al,[bp].Color
   mov bx,[bp].XAdvance
YMajorFirstLoop:
   mov [di],al
   add di,SCREEN_WIDTH
   dec cx
   jnz YMajorFirstLoop
   add di,bx
   cmp si,1
   jna YMajorDrawLast
   dec dx
   shr si,1
   jnc YMajorFullRunsOddEntry
YMajorFullRunsLoop:
   mov cx,[bp].WholeStep
   add dx,[bp].AdjUp
   jnc YMajorNoExtra
   inc cx
   sub dx,[bp].AdjDown
YMajorNoExtra:
YMajorRunLoop:
   mov [di],al
   add di,SCREEN_WIDTH
   dec cx
   jnz YMajorRunLoop
   add di,bx
YMajorFullRunsOddEntry:
   mov cx,[bp].WholeStep
   add dx,[bp].AdjUp
   jnc YMajorNoExtra2
   inc cx
   sub dx,[bp].AdjDown
YMajorNoExtra2:
YMajorRunLoop2:
   mov [di],al
   add di,SCREEN_WIDTH
   dec cx
   jnz YMajorRunLoop2
   add di,bx

   dec si
   jnz YMajorFullRunsLoop
YMajorDrawLast:
   pop cx
YMajorLastLoop:
   mov [di],al
   add di,SCREEN_WIDTH
   dec cx
   jnz YMajorLastLoop
Done:
   pop ds di si
   mov sp,bp
   pop bp
   ret
Line endp
   end